// Objekte zum Zugriff auf die Adabas-Datenbank
//

#ifndef __DATABASE_H
#define __DATABASE_H

#include <WINDOWS.H>
#include <sql.h>

#include "collection.h"
#include "strcoll.h"

// limited by adabas
#define MAXCOLS	255

// tDatabase - das Zentrale Objekt

class tDatabase {
	public:
		tDatabase(char *n, char *u, char *p);
		tDatabase() { uid=pwd=name = NULL; working=0; };
		~tDatabase();

		void open();
		void connect() { open(); };
		void close();
		void disconnect() { close(); };

		void getHSTMT (HSTMT &hstmt);
		void freeHSTMT (HSTMT &hstmt);
		void ExecSQL ( char *s );
		void print_err(HSTMT hstmt);
		void CommitWork ();
		
	protected:
		// 0, falls nicht init, 1 falls init
		int		working;
		
		char	*uid;
		char	*pwd;
		char	*name;

		HENV	henv;
		HDBC	hdbc;
		UCHAR	errmsg[256];
};

class tDataSource {
	public:
		tDataSource(tDatabase *d);
		tDataSource(char *s, tDatabase *d);
		~tDataSource();

		void ExecSQL(char *s);
		void PrepareSQL (char *s);
		void SetParamSQL (); 
		void RunSQL ();
		void close ();
		tStrColl *getRow(int i);
		tStrColl *getColNames() { return rows; };
		SDWORD	getRowCount() { return rowcount; };
		SWORD	getResultCols() { return nresultcols; };
		void	reset();

	private:
		char	*sql;
		tStrColl *rows;
		tCollection *data;
		HSTMT	hstmt;
		tDatabase	*database;
		SWORD	nresultcols;
		SDWORD	rowcount;
		int		position;
		int		active;
};

#endif
